/*
 * Copyright (C) 2009 - 2011 Nokia Corporation.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 */

#ifndef APT_WORKER_MARKPOLICY_H
#define APT_WORKER_MARKPOLICY_H

#include "markpolicydepcache.h"
#include <glib.h>

class myMarkPolicy : public MarkPolicy
{
public: // MarkPolicy
    virtual bool IsInstallOk(const PkgIterator &Pkg, bool AutoInst,
			     unsigned long Depth, bool FromUser);
    virtual bool IsDeleteOk(const PkgIterator &Pkg, bool AutoInst,
			    unsigned long Depth, bool FromUser);

public:
    enum Mode {
	AllowAll,
	UserInstall
    };

    myMarkPolicy(Mode mode = AllowAll);

    void setMode(Mode mode);
    void error(GError **error) const;
    /*!
     * \return Valid VerIterator, if *OSMetaPackageVer or
     * *SystemUpdateVer is valid.
     */
    VerIterator illegalSysVer() const;

    static bool isOSMetaPackage(const VerIterator &v);
    static bool isUserInstalled(const PkgIterator &p);
    static bool isUserInstallable(const VerIterator &v);
    static bool isVisible(const VerIterator &v);

    // Flags used by IsInstallOk(), IsDeleteOk():
    bool nonAutoInstMustBeUserInstallable;
    bool nonAutoInstMustBeUserInstallableStops;
    bool forbidMarkOSMetaPackage;
    bool forbidMarkOSMetaPackageStops;
    bool forbidBreakVisiblePackage;
    bool forbidBreakVisiblePackageStops;
    bool breaksOSMetaPackage;

    // Packages detected by IsInstallOk(), IsDeleteOk():
    VerIterator installOSMetaPackageVer;
    VerIterator deleteOSMetaPackageVer;
    VerIterator breakVisiblePackageVer;

    bool debug;
};

#endif
