/*
 * Copyright (C) 2009 - 2011 Nokia Corporation.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 */

#ifndef APT_WORKER_H
#define APT_WORKER_H

#include <glib.h>

#include "package.h"
#include "apt-worker-utils.h"
#include "package.h"

typedef enum _PkgTrust {
  PKGTRUST_END,
  PKGTRUST_NOT_CERTIFIED,
  PKGTRUST_DOMAINS_VIOLATED
} PkgTrust;

typedef enum _PkgSort {
	PKG_SORT_NAME, /* <  sort by name*/
	PKG_SORT_RELEASE_TIME, /* < sort by release time*/
	PKG_SORT_INSTALL_TIME, /* < sort by installation time*/
} PkgSort;

#include "apt-worker-internal.h"

ResultCode operation (bool check_only,
		      const char *alt_download_root,
		      bool download_only,
		      GError **error,
		      bool allow_download,
		      bool with_status,
		      int *pkgflags);

#endif // APT_WORKER_H

