/*
 * Copyright (C) 2009 - 2011 Nokia Corporation.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 */

#ifndef ARCHIVECLEANER_H
#define ARCHIVECLEANER_H

#include <apt-pkg/clean.h>
#include <apt-pkg/depcache.h>
#include <sys/stat.h>

/*!
 * Clean package files that are no longer needed.  No longer needed
 * files are either:
 *
 * - Nonfetchable package files (as pkgArchiveCleaner does).
 * - Succesfully installed or older versions.
 *
 * Based on pkgArchiveCleaner.
 */
class ArchiveCleaner : public pkgArchiveCleaner
{
public:
   ArchiveCleaner(pkgDepCache &DCache) : DCache(DCache) { }

   bool Go(string Dir,pkgCache &Cache);

protected:
   virtual void Erase(const char * /*File*/,string /*Pkg*/,string /*Ver*/,struct stat & /*St*/);

   pkgDepCache &DCache;
};

#endif
