/*
 * Copyright (C) 2009 - 2011 Nokia Corporation.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 */

#ifndef CATALOGUES_H
#define CATALOGUES_H

#include <string>
#include <string.h>

#include <glib.h>

#include "xexp.h"

using namespace std;

#define TEMP_APT_SOURCE_LIST "/etc/apt/sources.list.d/package-manager-temp.list"

/** MANAGEMENT FOR FAILED CATALOGUES LOG FILE
 */

/* Since it's needed to save the full report (including errors) after
   any refresh of the catalogues list, four functions were implemented
   to take care of the writting/reading to/from disk process.
*/

void save_failed_catalogues (xexp *catalogues);
// xexp *load_failed_catalogues ();
void clean_failed_catalogues ();
void clean_temp_catalogues ();
// xexp *merge_catalogues_with_errors (xexp *catalogues);

void
reset_catalogue_errors (xexp *catalogues);

gchar*
find_catalogue_by_info (const char* p_uri,
                        const char* p_dist,
                        const char* p_comp,
			gboolean find_disabled);

GList *
find_catalogues_for_item_desc (xexp *catalogues, string desc_uri);

gboolean
update_sources_list (xexp *catalogues);

GList*
catalogues_get_all ();

#endif /* CATALOGUES_H */
