/*
 * Copyright (C) 2009 - 2011 Nokia Corporation.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 */

#ifndef ERROR_H
#define ERROR_H

#include <glib.h>

G_BEGIN_DECLS

#define PKGMGRD_ERROR g_quark_from_static_string("pkgmgrd-error")

typedef enum _PkgmgrdError {
	ERROR_INVALID_ARGUMENT,
	ERROR_FILE_NOT_FOUND,
	ERROR_PACKAGE_NOT_FOUND,
	ERROR_PACKAGE_VERSION_NOT_FOUND,
	ERROR_INVALID_FILE,
	ERROR_INVALID_PACKAGE,
	ERROR_PACKAGE_NOT_COMPATIBLE,
	ERROR_PACKAGE_NOT_USER,
	ERROR_MISSING_DEPENDENCIES,
	ERROR_PACKAGE_NOT_INSTALLED,
	ERROR_PACKAGE_ALREADY_INSTALLED,
	ERROR_PACKAGE_ALREADY_NEWEST,
	ERROR_CHECK_UPDATES_FAILED,
	ERROR_NO_CANDIDATE,
	ERROR_OPERATION_FAILED,
	ERROR_UPGRADE_FAILED,
	ERROR_CATALOGUE_NOT_FOUND,
	ERROR_ACCESS_DENIED,
	ERROR_CATALOGUE_ALREADY_EXISTS,
	ERROR_SERVICE_SHUTDOWN,
	ERROR_NOT_ENOUGH_SPACE,
	ERROR_NEED_DOWNLOAD,
	ERROR_PACKAGE_REQUIRES_SYSTEM_PACKAGE,
	ERROR_PACKAGE_REQUIRES_SYSTEM_UPGRADE,
	ERROR_PACKAGE_IS_SYSTEM_PACKAGE,
	ERROR_DOWNLOAD_FAILED,
	ERROR_NO_OPERATION,
	ERROR_INVALID_OPERATION,
	ERROR_NOT_CANCELABLE,
	ERROR_OPERATION_CANCELED,
	ERROR_DEPENDENCIES_PREVENT_UNINSTALL,
	ERROR_DEPENDENCIES_PREVENT_OPERATION,
	ERROR_NEED_DOWNGRADE,
	ERROR_LOW_BATTERY_LEVEL,
	ERROR_INTERNAL,
	ERROR_PARTIAL_SUCCESS,
	ERROR_REMOVED_BY_SYSTEM_UPGRADE,
	ERROR_PACKAGE_NOT_COMPATIBLE_WITH_SYSTEM
} PkgmgrdError;

#define PKGMGR_DBUS_ERROR "com.nokia.package_manager.Error"

const gchar*
pkgmgr_error_to_dbus_error(PkgmgrdError err);

G_END_DECLS

#endif // ERROR_H
