/*
 * Copyright (C) 2009 - 2011 Nokia Corporation.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 */

#ifndef FORMAT_METADATA_H
#define FORMAT_METADATA_H

#include <glib.h>

/*!
  Format Debian multiline field such as Description for display.

  \param len Number of characters to process, or -1 to use
  strlen(str).

  \param join_paragraphs If set, join lines belonging to same
  paragraph in one line.

  \pre str != NULL

  \see http://www.debian.org/doc/debian-policy/ch-controlfields.html#s-f-Description
*/
gchar *format_multiline_field (const gchar *str, int len = -1, bool join_paragraphs = true);

gchar *format_utf8(const gchar* text);

#endif
