#!/bin/sh

DELAY=0

while getopts d: opt; do
    case "$opt" in
	d) DELAY="$OPTARG";;
	*) exit 2;;
    esac
done
shift `expr $OPTIND - 1`

if grep -q "^disableReboot[[:space:]]*=[[:space:]]*[^0]" /etc/package-manager/config
then
    echo "disableReboot set in config, doing nothing."
    echo "$@" > /var/tmp/pkgmgrd.reboot
    exit 0
fi

if [ $DELAY -ge 0 ]; then
    echo "$0: Rebooting in $DELAY seconds..."
    sleep $DELAY
fi

echo "$0: Rebooting (command: reboot $@)..."
reboot $@
