<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0"
		xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:output method="text" />

<xsl:template match="/">
  <xsl:apply-templates select="/node//interface" />
</xsl:template>

<xsl:template match="interface">
  <xsl:text>.TH </xsl:text>
  <xsl:value-of select="@name" />
  <xsl:text>
.SH NAME
</xsl:text>
  <xsl:value-of select="@name" />
  <xsl:text> - Maemo Package Manager daemon D-Bus interface
</xsl:text>
  <xsl:text>.SH METHODS
</xsl:text>
    <xsl:apply-templates select="method" />
    <xsl:text>.SH STANDARDS
.IP " 1. "
D-Bus specification, v0.12:
.RS
http://dbus.freedesktop.org/doc/dbus-specification.html
</xsl:text>
</xsl:template>

<xsl:template match="arg">
  <xsl:param name="name"><xsl:value-of select="@name" /></xsl:param>
  <xsl:text>.TP
\fI</xsl:text>
  <xsl:value-of select="@name" />
  <xsl:text>\fP
</xsl:text>
  <xsl:value-of select="../annotation[@name=$name]/@value" />
  <xsl:text>
</xsl:text>
</xsl:template>

<xsl:template match="method">
<xsl:param name="name"><xsl:value-of select="@name" /></xsl:param>
<xsl:text>.SS
.BI "</xsl:text>
  <xsl:value-of select="@name" />
  <xsl:text>(</xsl:text>
  <xsl:for-each select="arg">
    <xsl:value-of select="@direction" />
    <xsl:text> </xsl:text>
    <xsl:value-of select="@type" />
    <xsl:text> " </xsl:text>
    <xsl:value-of select="@name" />
    <xsl:if test="not (position()=last())">
      <xsl:text> ", </xsl:text>
    </xsl:if> 
  </xsl:for-each>
  <xsl:text> ")"
.P
</xsl:text>
  <xsl:value-of select="annotation[@name=$name]/@value" />
<xsl:text>
</xsl:text>
<xsl:apply-templates select="arg" />

<!--  <xsl:for-each select="ancestor::annotation">
    <xsl:if test="@name = name()">
      <xsl:value-of select="./@value"/>
    </xsl:if>
  </xsl:for-each> -->

</xsl:template>

</xsl:stylesheet>
