/*
 * Copyright (C) 2009 - 2011 Nokia Corporation.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 */

#ifndef DBUS_OPERATORS_H
#define DBUS_OPERATORS_H
#include <QtDBus/QDBusArgument>

struct Package
{
	QMap<QString, QVariant> p;
};

struct PackageArray
{
	QList< QMap<QString, QVariant> > packages;
};

struct Catalogue
{
	QMap<QString, QVariant> p;
};

struct CatalogueArray
{
	QList< QMap<QString, QVariant> > catalogues;
};


Q_DECLARE_METATYPE(Package)
Q_DECLARE_METATYPE(PackageArray)
Q_DECLARE_METATYPE(Catalogue)
Q_DECLARE_METATYPE(CatalogueArray)

QDBusArgument &operator<<(QDBusArgument &s, const Package &data);
const QDBusArgument &operator>>(const QDBusArgument &s, Package &data);

QDBusArgument &operator<<(QDBusArgument &s, const PackageArray &data);
const QDBusArgument &operator>>(const QDBusArgument &s, PackageArray &data);

QDBusArgument &operator<<(QDBusArgument &s, const Catalogue &data);
const QDBusArgument &operator>>(const QDBusArgument &s, Catalogue &data);

QDBusArgument &operator<<(QDBusArgument &s, const CatalogueArray &data);
const QDBusArgument &operator>>(const QDBusArgument &s, CatalogueArray &data);

#endif /* DBUS_OPERATORS_H */
