/*
 * Copyright (C) 2009 - 2011 Nokia Corporation.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 */

#ifndef PACKAGEMANAGER_P_H
#define PACKAGEMANAGER_P_H

#include <QtDBus/QDBusPendingReply>
#include <QObject>
#include <QMap>
#include <QList>
#include <QVariant>

#include "packagemanager.h"

class QString;
class QDBusError;
class QDBusPendingCallWatcher;
class package_manager;
class PackageManager;
class PackageManagerPendingCallWatcher;
class PackageManagerPendingFetchWatcher;
class package_manager_install_uiProxy;

namespace com {
  namespace nokia {
    typedef ::package_manager package_manager;
  }
}

class PackageManagerPrivate : public QObject
{
    Q_OBJECT
    Q_DECLARE_PUBLIC(PackageManager)

public:
    PackageManagerPrivate();
    ~PackageManagerPrivate();
    static PackageManager::ErrorCode errorNameToCode( const QString& errorName );

public:
    com::nokia::package_manager* pm;
    package_manager_install_uiProxy* uiProxy;
    PackageManager* q_ptr;
};

#endif
