# qmake custom compiler for qdbusxml2cpp
#
# Usage in .pro file:
#
# QDBUSXML2CPP_FLAGS = -i dbus-operators.h  # optional
# QDBUSXML2CPP_FILES = ../path/to/com.acme.foobar.xml
# include(qdbusxml2cpp.pri)

isEmpty(QDBUSXML2CPP_FLAGS):QDBUSXML2CPP_FLAGS =

qdbusxml2cpp_src.name = QDBUSXML2CPP_SRC ${QMAKE_FILE_IN}
qdbusxml2cpp_src.output = ${QMAKE_FILE_IN_BASE}.cc
qdbusxml2cpp_src.variable_out = SOURCES
qdbusxml2cpp_src.commands = touch ${QMAKE_FILE_OUT}
qdbusxml2cpp_src.input = QDBUSXML2CPP_FILES
QMAKE_EXTRA_COMPILERS += qdbusxml2cpp_src

qdbusxml2cpp_h.name = QDBUSXML2CPP_H ${QMAKE_FILE_IN}
qdbusxml2cpp_h.CONFIG = explicit_dependencies
qdbusxml2cpp_h.output = ${QMAKE_FILE_IN_BASE}.h
qdbusxml2cpp_h.variable_out = HEADERS
qdbusxml2cpp_h.commands = qdbusxml2cpp -c `echo ${QMAKE_FILE_IN_BASE}|sed 's/^.*[.]//'` -p ${QMAKE_FILE_OUT}:${QMAKE_FILE_OUT_BASE}.cc ${QMAKE_FILE_IN} $$QDBUSXML2CPP_FLAGS
qdbusxml2cpp_h.input = QDBUSXML2CPP_FILES
qdbusxml2cpp_h.depends = ${QMAKE_FILE_IN_BASE}.cc
QMAKE_EXTRA_COMPILERS += qdbusxml2cpp_h

qdbusxml2cpp.name = QDBUSXML2CPP_H ${QMAKE_FILE_IN}
qdbusxml2cpp.CONFIG = explicit_dependencies
qdbusxml2cpp.output = moc_${QMAKE_FILE_IN_BASE}.cpp
qdbusxml2cpp.variable_out = SOURCES
qdbusxml2cpp.commands = moc $(DEFINES) $(INCPATH) -o ${QMAKE_FILE_OUT} ${QMAKE_FILE_IN_BASE}.h
qdbusxml2cpp.input = QDBUSXML2CPP_FILES
qdbusxml2cpp.depends = ${QMAKE_FILE_IN_BASE}.h
QMAKE_EXTRA_COMPILERS += qdbusxml2cpp
