/*
 * Copyright (C) 2009 - 2011 Nokia Corporation.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 */

#ifndef GLIB_UTIL_H
#define GLIB_UTIL_H

#include <glib.h>

G_BEGIN_DECLS

void g_hash_table_free_values (GHashTable *map);
void g_hash_table_insert_string_value (GHashTable *map, const gchar *key, const gchar *s);
void g_hash_table_replace_string_value (GHashTable *map, const gchar *key, const gchar *s);
void g_hash_table_insert_int_value (GHashTable *map, const gchar *key, gint i);
void g_hash_table_insert_int64_value (GHashTable *map, const gchar *key, gint64 i);
void g_hash_table_insert_boolean_value (GHashTable *map, const gchar *key, gboolean b);

const gchar *
g_hash_table_get_string_value (GHashTable *map, const gchar *key);
gint64
g_hash_table_get_int64_value (GHashTable *map, const gchar* key);
gint
g_hash_table_get_int_value (GHashTable *map, const gchar *key);
gboolean
g_hash_table_get_boolean_value (GHashTable *map, const gchar *key);

gchar **strsplitv (const gchar *sc, char sep);

G_END_DECLS

#endif
