/*
 * Copyright (C) 2009 - 2011 Nokia Corporation.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 */

#ifndef PACKAGE_MAP_H
#define PACKAGE_MAP_H

#include <glib.h>
#include <stdio.h>
#include <glib-object.h>

G_BEGIN_DECLS

typedef struct _Field {
  gchar *key;
  int type;
  GValue *value;
} Field;

void package_hash_table_free (GHashTable *p);
gboolean package_hash_table_fread (GHashTable **pp, FILE *f);
gboolean package_hash_table_fwrite (GHashTable *p, FILE *f);
/* gboolean package_hash_table_ptr_array_fread (GPtrArray **pp, FILE *f); */
/* gboolean package_hash_table_ptr_array_fwrite (GPtrArray *pp, FILE *f); */
gboolean package_hash_table_list_fread (GList **pp, FILE *f);
gboolean package_hash_table_list_fwrite (GList *p, FILE *f);

gboolean _read_field (FILE *f, char **line, size_t *len, Field **fieldpp);
gboolean _write_value (FILE *f, const char *key, GValue *val);

G_END_DECLS

#endif
