/*
 * Copyright (C) 2009 - 2011 Nokia Corporation.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 */

#ifndef SERIALIZE_H
#define SERIALIZE_H

#include <glib.h>
#include <stdio.h>

G_BEGIN_DECLS

gchar *
decode_strdup (const char *str, size_t len);

gboolean
get_str (FILE *f, char **line, size_t *len, gchar **p);

gboolean
get_strv (FILE *f, char **line, size_t *len, gchar ***v);

gboolean
get_int (FILE *f, char **line, size_t *len, gint *p);

gboolean
get_boolean (FILE *f, char **line, size_t *len, gboolean *p);

gboolean
get_int64 (FILE *f, char **line, size_t *len, gint64 *p);

gboolean
get_hash_table (FILE *f, char **line, size_t *len, GHashTable **p);

gboolean
put_str (FILE *f, const char *s);

gboolean
put_strv (FILE *f, gchar **v);

gboolean
put_int (FILE *f, gint i);

gboolean
put_boolean (FILE *f, gboolean b);

gboolean
put_int64 (FILE *f, gint64 v);

gboolean
put_hash_table (FILE *f, GHashTable *v);

G_END_DECLS

#endif
