/*
 * Copyright (C) 2009 - 2011 Nokia Corporation.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 */

#ifndef CHECK_COMMON_H
#define CHECK_COMMON_H

#include <check.h>

#define fail_if_GError(gerror) fail_if(gerror != 0, gerror && gerror->message ? gerror->message : 0)

#define CHECK_MAIN(suite_fn)				       \
	int main (int argc, char *argv[])		       \
	{						       \
		get_options (argc, argv);		       \
		return run_suite (suite_fn ())		       \
			? EXIT_SUCCESS : EXIT_FAILURE;	       \
	}

extern int verbosity;
extern int fork_mode;
extern print_output output_level;
extern int tc_timeout_s;
extern const char *test_dir;

void get_options (int argc, char *argv[]);

bool run_suite (Suite *suite);

bool init_test_install ();
bool init_test_update ();

#endif
