/*
 * Copyright (C) 2009 - 2011 Nokia Corporation.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 */

// -*- Mode: C++; c-basic-offset: 8 -*-
#include <check.h>
#include <getopt.h>
#include <stdio.h>
#include <stdlib.h>
#include <glib-object.h>
#include "apt-worker-thread.h"
#include "check-common.h"
#include "package-map.h"

static void package_list_print (GList *P)
{
	for (GList *i = g_list_first (P); i != NULL; i = g_list_next (i))
		package_hash_table_fwrite (static_cast<GHashTable *> (i->data), stdout);
}

START_TEST (test_cmd_get_package_dep_details)
{
	g_type_init ();
	g_thread_init (NULL);
	AptWorker *apt_worker = apt_worker_new ();
	apt_worker->init (NULL, NULL, NULL, NULL, NULL, NULL, NULL);

	GList *P;
	GError *error = NULL;
	P = apt_worker->cmd_get_package_dep_details ("hpm-user-valid-deps", NULL, &error);
	fail_if_GError (error);
	// printf ("%d\n", g_list_length (P));
	fail_unless (g_list_length (P) == 1+5);
	// package_list_print (P);
}
END_TEST

Suite *
get_package_dep_details_test_suite ()
{
	Suite *s = suite_create ("get_package_dep_details");
	TCase *tc;

	tc = tcase_create ("get_package_dep_details");
	tcase_set_timeout(tc, 180);
	tcase_add_test (tc, test_cmd_get_package_dep_details);
	suite_add_tcase (s, tc);

	return s;
}

int main (int argc, char *argv[])
{
	tc_timeout_s = 30;

	get_options (argc, argv);

	fork_mode = 0;

	return run_suite (get_package_dep_details_test_suite ())
		? EXIT_SUCCESS : EXIT_FAILURE;
}
