source `dirname $0`/testvars.sh

if [ "xSBOX_PRELOAD" != "x" ]; then
    LD_PRELOAD=$SBOX_PRELOAD
fi

maybe_create_package ()
{
    PKGNAME=$1
    PKGVER=$2
    PKGSECTION=$3
    ARCH=$4
    DEPS=$5
    PRE_INST_DELAY=$6
    if [ "x$PRE_INST_DELAY" == "x" ]; then
	PRE_INST_DELAY=0
    fi
    POST_INST_DELAY=$7
    if [ "x$POST_INST_DELAY" == "x" ]; then
	POST_INST_DELAY=0
    fi
    DEB="${PKGNAME}_${PKGVER}*_${ARCH}.deb"

    if [ ! -f $DEB ]; then
	echo "PKG: ${PKGNAME}_${PKGVER}_${ARCH}, DEPS: $DEPS"
	set -e
	if [ "x$DEPS" == "x" ]; then
	    deb-create -d tmp -n $PKGNAME -V $PKGVER -s $PKGSECTION -a $ARCH -i $PRE_INST_DELAY -I $POST_INST_DELAY
        else
	    echo "DEPS: $DEPS"
	    deb-create -d tmp -n $PKGNAME -V $PKGVER -s $PKGSECTION -a $ARCH -D $DEPS -i $PRE_INST_DELAY -I $POST_INST_DELAY
	fi
	set +e
    fi
}

# Install test packages
maybe_create_package usertestpkg 0.1.0 user/development $HOST_ARCH
maybe_create_package usertestpkg 0.1.1 user/development $HOST_ARCH
maybe_create_package nonusertestpkg 0.1.0 misc $HOST_ARCH
maybe_create_package nonusertestpkg 0.1.1 misc $HOST_ARCH
maybe_create_package invalidarchtestpkg 0.1.0 user/development powerpc
maybe_create_package missingdepstestpkg 0.1.0 user/development $HOST_ARCH missingdependency
maybe_create_package dependencytestpkg 0.1.0 user/development $HOST_ARCH
maybe_create_package validdependenciestestpkg 0.1.0 user/development $HOST_ARCH ,dependencytestpkg,nonusertestpkg
maybe_create_package localtestpkg 0.1.0 user/desktop $HOST_ARCH

maybe_create_package longinstalltestpkg 0.1.0 user/development $HOST_ARCH '' 20 20

# Update test packages
maybe_create_package missingdepsupgradepkg 0.1.0 user/development $HOST_ARCH ,dependencytestpkg,nonusertestpkg
maybe_create_package missingdepsupgradepkg 0.1.1 user/development $HOST_ARCH ,missingdependency,dependencytestpkg,nonusertestpkg
maybe_create_package updatetestpkg 0.1.0 user/development $HOST_ARCH
maybe_create_package updatetestpkg 0.1.1 user/development $HOST_ARCH
