#!/bin/bash

SCRIPTDIR=`dirname $0`

set -e

if [ "$_SBOX_DIR" != '' ]; then
    echo Error: this script must be run outside Scratchbox environment.
    exit 1
fi

XEPHYR_PID=

function cleanup {
    trap - INT TERM EXIT
    echo $0: error, cleanup
    kill $XEPHYR_PID
}

trap cleanup INT TERM EXIT

Xephyr :1 -host-cursor -screen 864x480x16 -dpi 96 -ac -extension Composite >/tmp/Xephyr.log 2>&1 &
XEPHYR_PID=$!
sleep 1

cat <<EOF | scratchbox -s | tail -n +0
cd $PWD
./run-test-libpkgmgr-dbus-qt.sh
EOF

sleep 1
trap - INT TERM EXIT
kill $XEPHYR_PID
