/*
 * Copyright (C) 2009 - 2011 Nokia Corporation.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 */

#ifndef MOCK_APT_WORKER_H
#define MOCK_APT_WORKER_H

#include "apt-worker-struct.h"

typedef struct {
	AptWorker base;

	DownloadProgressFunc download_progress_fn;
	OperationStartedFunc operation_started_fn;
	OperationProgressFunc operation_progress_fn;
	gpointer progress_data;

	const gchar *category;
	PkgType type;
	const gchar *pattern;
	PkgSort sort;
	int limit;
	const char *package;
	const char *version;
	gboolean installed;
	const char *filename;
	const char *alt_download_root;
	gboolean with_status;
	const gchar *name;
	gboolean enable;
        const gchar *flags;

	GList *retval_catalogues;
	gboolean retval_boolean;
	GList *retval_packages;
	Package *retval_pkg_list_info;
	ResultCode retval_result_code;
	GHashTable *retval_pkg_map;
	gchar* retval_status;
} MockAptWorker;

AptWorker *mock_apt_worker_new ();
void init_mock_apt_worker (MockAptWorker *self);

#endif
