#!/bin/bash
#set -v
set -e
if [ $1 ];
then
  DEV_IP=$1
  PING_REPLY_NOK=`ping -c 1 $DEV_IP -w 1 | grep -o "0 received";true`

  if [ "$PING_REPLY_NOK" == "0 received" ];
  then
    echo "Could not ping device on address '$DEV_IP'. Check the device connection and configuration."
  else
    echo "The script will replace the NFT scripts on connected device."
    echo "This means that contents of '/usr/share/package-manager-tests/nft' directory are removed."
    echo -n "Is this OK [y/N]? "
    read confirmation
    if [ "$confirmation" == "y" ]
    then
      # Remove NFT directory on device (ignore if not found)
      ssh root@$DEV_IP 'rm -R /usr/share/package-manager-tests/nft;true'
      
      # Create new directories (will also create nft)
      ssh root@$DEV_IP 'mkdir -p /usr/share/package-manager-tests/nft/scripts'

      # Copy test scripts to device
      scp generate-tests.xml root@$DEV_IP:/usr/share/package-manager-tests/nft
      scp run_test.py root@$DEV_IP:/usr/share/package-manager-tests/nft
      scp test_on_device root@$DEV_IP:/usr/share/package-manager-tests/nft
      scp scripts/* root@$DEV_IP:/usr/share/package-manager-tests/nft/scripts
    
      # Run scripts
      ssh root@$DEV_IP '/usr/share/package-manager-tests/nft/test_on_device'

      # Collect test definition file and results file back to PC
      scp root@$DEV_IP:/usr/share/package-manager-tests/nft/nft_tests.xml .
      scp root@$DEV_IP:/usr/share/package-manager-tests/nft/response_results.xml .
    fi 
  fi
else
  echo "USAGE: run_tests_on_device_ssh.sh [ DEVICE_IP_ADDRESS ]"
  echo 
  echo "For example: run_tests_on_device_ssh.sh 192.168.2.15" 
  echo
fi

