#!/bin/sh
#
# Reproduce bug #160918.
#
# Link: https://projects.maemo.org/bugzilla/show_bug.cgi?id=160918

set -e
D=`dirname $0`
source $D/testvars.sh
PKG=/var/tmp/package-manager/testrepo/pool/user/desktop/hpm-user1_0.1.0-1_${HOST_ARCH}.deb
if test -x $D/../cli/pkgmgr; then
    export PATH=$D/../cli:$D/../daemon:$D:$PATH
fi

query_proc() {
    while [ 1 ]; do
	pkgmgr package-dep-details -p hpm-user1 >/dev/null
    done
}

init() {
    setup-testrepo.sh
    start_pkgmgrd.sh
}

PID=
cleanup() {
    stop_pkgmgrd.sh
    kill $PID
}

trap cleanup EXIT
init
query_proc &
PID=$!
pkgmgr install-file -f $PKG
echo Success
