source `dirname $0`/testvars.sh

# print $2 if $1 <= $VERBOSE
print()
{
    local level=$1

    while read line
    do
	if [ $1 -le $VERBOSE ]
	then
	    cat
	fi
    done
}
maybe_create_repo ()
{
    if [ ! -d $REPODIR ]; then
	mkdir -p $REPODIR
	if [ $? -ne 0 ]; then
	    echo $0: error: could not create path $REPODIR >/dev/stderr
	    exit 1
	fi

	#repotool uninstall $REPONAME
    fi
    repotool install $REPODIR default 'user main' | print 1
}

create_repo_with_catalogue ()
{
    local reponame=$1
    local repodir=$2
    local dist=default
    local components="user main"
    local uri="file://$repodir"

    if [ ! -d $repodir ]; then
	mkdir -p $repodir
	if [ $? -ne 0 ]; then
	    echo $0: error: could not create path $repodir >/dev/stderr
	    exit 1
	fi

	#./repotool uninstall $REPONAME
	deb-repo-init -d $repodir -n $dist -s user -s main
    fi

    cat >/etc/apt/sources.list.d/package-manager.list <<EOF
deb $uri $dist $components
EOF
#	./repotool install $repodir $dist $components | print 1

    cat >/etc/package-manager/catalogues <<EOF
<catalogues>
 <catalogue>
  <name>$reponame</name>
  <uri>$uri</uri>
  <dist>$dist</dist>
  <components>$components</components>
  <essential />
 </catalogue>
</catalogues>
EOF
}

remove_all_repo_packages ()
{
    local INST_TESTPKGS="usertestpkg nonusertestpkg dependencytestpkg validdependenciestestpkg longinstalltestpkg missingdepsupgradepkg"

    for pkg in $INST_TESTPKGS; do
	set +e
	$FAKEROOT apt-get -qq remove -y --force-yes $pkg </dev/null| print 1
	set -e
    done

    if [ -d $REPODIR/pool ]; then
	find $REPODIR/pool/ -name "*.deb" -type f -exec rm '{}' \;
    fi

    repotool update $REPONAME | print 1

    # Hack: apt-get update fails with missing Maemo repos
    set +e
    $FAKEROOT apt-get -qq update 2>/dev/null </dev/null| print 1
    echo -n # $?=0
    set -e
}

REPODIR=$TESTDIR/$REPONAME

if [ $VERBOSE -ge 1 ]; then
    echo "Using test directory \"$TESTDIR\""
    echo "Using repository directory \"$REPODIR\""
    echo "Using repository name \"$REPONAME\""
fi

if test ! -d /etc/package-manager; then
    mkdir -p /etc/package-manager
fi

#create_repo_with_catalogue TestEssential /tmp/pkgmgr-test/TestEssential
maybe_create_repo

