#!/usr/bin/python
#
# Copyright (C) 2009 - 2011 Nokia Corporation.
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License version
# 2 as published by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see http://www.gnu.org/licenses/.



config_items = { "[Main]" : {} }

CONFIG_FILE = '/etc/package-manager/config'

import os

def update_config(section, key, value):
    section_dict = config_items.get(section, {})
    section_dict.update({ key : value })
    config_items.update({section : section_dict})

def read_config():
    if os.path.exists(CONFIG_FILE):
        with open(CONFIG_FILE, 'r') as f:
            section = None
            for line in f:
                if line.find('=') == -1:
                    section = line.strip()
                elif section is not None:
                    tuple = line.split('=')
                    key = tuple[0].strip()
                    value = tuple[1].strip()
                    section_dict = config_items.get(section, {})
                    section_dict.update({ key : value })
                    config_items.update({section : section_dict})

def write_config():
    if not os.path.exists('/etc/package-manager'):
        os.makedirs('/etc/package-manager')
    f = open(CONFIG_FILE, 'w')
    
    for section, section_dict in config_items.items():
       f.write("%s\n" % (section))
       for k, v in section_dict.items():
           f.write('%s=%s\n' % (k, v))
    f.close()

def write_value_to_config(section, key, value):
    read_config()
    update_config(section, key, value)
    write_config()
