#!/bin/sh
#
# Update test package list makefiles based on "make-debs.py print"
# output.

set -e

D=`cd $(dirname $0) && pwd`
P=$D:$D/..
PATH=$P:$PATH
PYTHONPATH=$P:$PYTHONPATH

if test -z "$1"; then
    echo "usage: $0 ARCH" >/dev/stderr
    exit 2
fi
arch="$1"

F=/dev/stdout
generate-test-debs.mk.py -a $arch create >$F
install_debs=`generate-test-debs.mk.py -a $arch print|grep '0\.1\.0'`
upgrade_debs=`generate-test-debs.mk.py -a $arch print|grep '0\.1\.1'`
echo "INSTALL_DEBS = `echo $install_debs`" >> $F
echo "UPGRADE_DEBS = `echo $upgrade_debs`" >> $F
