#!/bin/sh

set +e
D=`cd $(dirname $0) && pwd`

for i in `seq 1 5`; do
    if [ "$1" = "" ]
    then
	python $D/webserver.py -v start
    else
	python $D/webserver.py -v -s $1 start
    fi

    set +e
    for i in `seq 1 5`; do
        test -e /var/run/hpm-webserver.pid
        if test $? -eq 0; then
	    break
        fi
#    echo "pid file not found, retrying" >/dev/stderr
        sleep 1
    done
    
    srvpid=$(cat /var/run/hpm-webserver.pid)
    echo "webserver running, pid is $srvpid" >/dev/stderr

    for i in `seq 1 5`; do
        curl http://127.0.0.1:8080/testrepo/dists/default/Contents-i386 >/dev/null 2>&1
        if test $? -eq 0; then
	    exit 0
        fi
#    echo "could not connect, retrying" >/dev/stderr
        
        sleep 1
    done

    echo "no response from webserver, trying again" >/dev/stderr
    kill $srvpid || true
    sleep 5
done

echo "no response from webserver after five tries, giving up" >/dev/stderr
exit 1
