/*
 * Copyright (C) 2009 - 2011 Nokia Corporation.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 */

#ifndef TIMEDOPERATIONS_H
#define TIMEDOPERATIONS_H

#include <QObject>
#include <timed/interface>
#include <timed/event>
#include <timed/exception>

// timed reserved attribute keys
#define TIMED_ATTRIBUTE_KEY_APP QString("APPLICATION")

class TimedOperations : public QObject
{
private:
       Maemo::Timed::Interface *timedInterface;

public:
    TimedOperations();
    ~TimedOperations();

    /**
     * A method for checking if there are any events for the instance in the timed
     * @param instanceName The instance who's events are in question.
     * @return false if there are no events for the instance, otherwise true
     */
    bool checkForEvents(const QString &instanceName, uint *cookieId);

    bool addEventToTimed(const Maemo::Timed::Event &event);
    bool replaceEventToTimed(const Maemo::Timed::Event &event, const uint cookieId);
    bool cancelEvent(const uint cookieId);
};

#endif // TIMEDOPERATIONS_H
