/*
 * Copyright (C) 2009 - 2011 Nokia Corporation.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 */

#ifndef UPDATER_H
#define UPDATER_H

#include <QObject>

#include <timed/interface>
#include <timed/event>
#include <timed/exception>

#include "timedoperations.h"
#include "packagemanagerpendingcallwatcher.h"

#include "timeddefs.h"

class Updater : public QObject
{
    Q_OBJECT
private:
    TimedOperations *timed;

public:
    Updater();
    ~Updater();

    bool refreshCache();
    void addEventIfNoneExists();
    bool cancelEvent();

public Q_SLOTS:
    void operationComplete(const QString &operation, const QString &packagename, const QString &version, const QString &result, const bool need_reboot);
    void operationStarted(const QString &operation, const QString &packagename, const QString &version);
    void dbusError( PackageManagerPendingCallWatcher* watcher );

private:
    void reschedule(bool error=false, int min=0);
    void createEvent(Maemo::Timed::Event &event, bool error);
};

#endif // UPDATER_H
